//+------------------------------------------------------------------+
//|                                                  EURX_Candle.mq4 |
//|                               Copyright  2012, Gehtsoft USA LLC |
//|                                            http://fxcodebase.com |
//+------------------------------------------------------------------+
#property copyright "Copyright  2012, Gehtsoft USA LLC"
#property link      "http://fxcodebase.com"

#property indicator_separate_window
#property indicator_buffers 2

extern int MaxBars=100;
extern color Bullish = MediumSeaGreen;
extern color Bearish = Orange;
extern int CandleWidth=3;
extern bool Reverse=false;

double EURX[];

string Symbols[5];
double Weights[5];

int Window;

double PrH[], PrL[];

void DrawCandle(datetime T, double O, double C)
{
 string ObjName=""+T;
 color CandleColor;
 if (C>=O) CandleColor=Bullish; else CandleColor=Bearish;
 Window=WindowFind("EUR index");
 if (Window==-1) return;
 if (ObjectFind(ObjName+"R")!=-1)
 {
  ObjectSet(ObjName+"R", OBJPROP_TIME1, T);
  ObjectSet(ObjName+"R", OBJPROP_TIME2, T);
  ObjectSet(ObjName+"R", OBJPROP_PRICE1, O);
  ObjectSet(ObjName+"R", OBJPROP_PRICE2, C);
 }
 else
 {
  ObjectCreate(ObjName+"R", OBJ_TREND, Window, T, O, T, C);
 } 
 ObjectSet(ObjName+"R", OBJPROP_COLOR, CandleColor);
 ObjectSet(ObjName+"R", OBJPROP_RAY, false);
 ObjectSet(ObjName+"R", OBJPROP_WIDTH, CandleWidth);
 
 return;
}  


int init()
  {
   IndicatorShortName("EUR index");
   IndicatorDigits(Digits);
   SetIndexStyle(0,DRAW_NONE);
   SetIndexBuffer(0,PrH);
   SetIndexStyle(1,DRAW_NONE);
   SetIndexBuffer(1,PrL);
   
   Symbols[0]="EURUSD";
   Symbols[1]="EURGBP";
   Symbols[2]="EURJPY";
   Symbols[3]="EURSEK";
   Symbols[4]="EURCHF";
   
   Weights[0]=0.3155;
   Weights[1]=0.3056;
   Weights[2]=0.1891;
   Weights[3]=0.0785;
   Weights[4]=0.1113;

   return(0);
  }

int deinit()
  {
   Window=WindowFind("EUR index");
   if (Window!=-1)
   {
    ObjectsDeleteAll(Window, OBJ_TREND);
   }

   return(0);
  }
  
double SymbolCoeff(int Number, int pos, int Price)
{
 string Symb=Symbols[Number];
 datetime T=Time[pos];
 int bar=iBarShift(Symb, 0, T, false);
 double PriceV=iMA(Symb, 0, 1, 0, MODE_SMA, Price, bar);
 double Power=Weights[Number];
 double Coeff=MathPow(PriceV,Power);
 return (Coeff);
}  

int start()
{
 if(Bars<=3) return(0);
 int ExtCountedBars=IndicatorCounted();
 if (ExtCountedBars<0) return(-1);
 int pos;
 double xO, xC;
 int limit=Bars-2;
 if(ExtCountedBars>2) limit=Bars-ExtCountedBars-1;
 limit=MathMin(limit, MaxBars);
 pos=limit;
 while(pos>=0)
 {
  xO=34.38805726;
  xC=34.38805726;
  xO=xO*SymbolCoeff(0, pos, PRICE_OPEN);
  xO=xO*SymbolCoeff(1, pos, PRICE_OPEN);
  xO=xO*SymbolCoeff(2, pos, PRICE_OPEN);
  xO=xO*SymbolCoeff(3, pos, PRICE_OPEN);
  xO=xO*SymbolCoeff(4, pos, PRICE_OPEN);

  xC=xC*SymbolCoeff(0, pos, PRICE_CLOSE);
  xC=xC*SymbolCoeff(1, pos, PRICE_CLOSE);
  xC=xC*SymbolCoeff(2, pos, PRICE_CLOSE);
  xC=xC*SymbolCoeff(3, pos, PRICE_CLOSE);
  xC=xC*SymbolCoeff(4, pos, PRICE_CLOSE);
  if (Reverse)
  {
   xC=1/xC;
   xO=1/xO;
  }
  PrH[pos]=xC;
  PrL[pos]=xO;
  DrawCandle(Time[pos],xO,xC);
  pos--;
 } 

 return(0);
}


